import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.util.encoders.Hex;

import java.io.FileInputStream;
import java.security.Key;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.Security;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Enumeration;

public class OpenCIPS {

//    static {
//        Security.addProvider(new BouncyCastleProvider());
//    }

    /**
     * openssl cips 流程验证
     * use OpenSSL 1.1.1f  31 Mar 2020
     * @param args
     */
    public static void main(String[] args) {

        try{
            Security.addProvider(new BouncyCastleProvider());
            CertificateFactory certFactory= CertificateFactory
                    .getInstance("X.509", "BC");

            char[] keystorePassword = "123456".toCharArray();
            char[] keyPassword = "password".toCharArray();


            KeyStore keystore = KeyStore.getInstance("PKCS12", new BouncyCastleProvider());
            keystore.load(new FileInputStream("./openssl/sandbox.p12"), keystorePassword);
//            KeyStore keystore = KeyStore.getInstance("PKCS12");
//            keystore.load(new FileInputStream("./mystore.p12"), "p12passphrase".toCharArray());
            Enumeration<String> aliases =  keystore.aliases();


            System.out.println( keystore.size() );
            String alias = "";
            while ( aliases.hasMoreElements() ) {
                alias = aliases.nextElement();
            }

            System.out.println( alias );
            Certificate cert = keystore.getCertificate( alias );
            System.out.println(Hex.toHexString( cert.getPublicKey().getEncoded() ));


        } catch (Exception ex){
            ex.printStackTrace();
        }

    }

}
