import com.chakracoin.shsm.logiclayer.SM4Util;
import com.chakracoin.shsm.util.Util;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.util.Random;

public class Renzheng {

    private static final String path = "C:\\Users\\Cheney\\Desktop\\信达雅数据采集\\report1";
    private static final int len = 10;

    public static byte[] random(int len) {
        byte[] data = new byte[len];
        new Random().nextBytes(data);
        return data;
    }

    public static String clean(String str) {
        return str.replaceAll("\\s", "");
    }

    public static void main(String[] args) throws NoSuchAlgorithmException, NoSuchProviderException, IOException, IllegalBlockSizeException, NoSuchPaddingException, BadPaddingException, InvalidKeyException {
        sm4de();
    }

    public static void sm4de() throws NoSuchAlgorithmException, NoSuchProviderException, IOException {
        System.out.println("sm4 解密");
//        sm4de_ecb();
//        sm4de_cbc();

        for ( int i = 0 ; i < 20 ; i ++ ) {
            System.out.println( Util.bytes2HexString( random( 16 ) ) );
        }

    }


    public static void writeLn(OutputStream fos, String str) throws IOException {
        fos.write(str.getBytes());
        fos.write("\r\n".getBytes());
        fos.flush();
    }

    public static void sm4de_ecb() throws NoSuchAlgorithmException, NoSuchProviderException, IOException {

        File file = new File(path, "SM4_DEC_ECB.txt");
        if (file.exists()) {
            file.delete();
        }
        file.createNewFile();

        try (
                FileOutputStream fos = new FileOutputStream(file)

        ) {


            for (int i = 0; i < len; i++) {
                byte[] key = SM4Util.generateKey();
                writeLn(fos, "");
                writeLn(fos, "密钥= " + Util.bytes2HexString(key));
                int len = (i + 1) * 16;
                writeLn(fos, "密文长度= " + String.format("%08X", len));
                byte[] data1 = random(len);
                writeLn(fos, "密文= " + Util.bytes2HexString(data1));
                byte[] data2 = SM4Util.decrypt_ECB_NoPadding(key, data1);
                writeLn(fos, "明文= " + Util.bytes2HexString(data2));
            }

        } catch (IOException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        }


    }

    public static void sm4de_cbc() throws IOException {

        File file = new File(path, "SM4_DEC_CBC.txt");
        if (file.exists()) {
            file.delete();
        }
        file.createNewFile();

        try (
                FileOutputStream fos = new FileOutputStream(file)

        ) {


            for (int i = 0; i < len; i++) {
                byte[] key = SM4Util.generateKey();
                byte[] iv = SM4Util.generateKey();
                writeLn(fos, "");
                writeLn(fos, "密钥= " + Util.bytes2HexString(key));
                writeLn(fos, "IV= " + Util.bytes2HexString(iv));

                int len = (i + 1) * 16;
                writeLn(fos, "密文长度= " + String.format("%08X", len));
                byte[] data1 = random(len);
                writeLn(fos, "密文= " + Util.bytes2HexString(data1));
                byte[] data2 = SM4Util.decrypt_CBC_NoPadding(key, iv, data1);
                writeLn(fos, "明文= " + Util.bytes2HexString(data2));
            }

        } catch (IOException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchProviderException e) {
            e.printStackTrace();
        } catch (InvalidAlgorithmParameterException e) {
            e.printStackTrace();
        }


    }

}
