package com.chakracoin.shsm.test;

import com.chakracoin.shsm.logiclayer.SM2Util;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.openssl.PEMWriter;
import org.bouncycastle.openssl.jcajce.JcaPEMKeyConverter;

import java.io.*;
import java.security.KeyPair;
import java.security.Security;

public class SM2KeyUtilTest {
    public static void main(String[] args) throws Exception {

        AsymmetricCipherKeyPair keyPair = SM2Util.generateKeyPairParameter();
        ECPrivateKeyParameters priKey = (ECPrivateKeyParameters) keyPair.getPrivate();
        ECPublicKeyParameters pubKey = (ECPublicKeyParameters) keyPair.getPublic();

        String der = privateKeyToDER(priKey);

        System.out.println( der );

        // SO22963581BCPEMPrivateEC();
    }

    /**
     * 仅支持国密标准 SM2 密钥
     * 便利法门，并不严谨
     * @param priKey
     */
    static String privateKeyToDER(ECPrivateKeyParameters priKey ){
        String hex = priKey.getD().toString(16);
        return privateKeyToDer( hex );
    }


    /**
     * 仅支持国密标准 SM2 密钥
     * 便利法门，并不严谨
     * @param hexKey 长度 64
     * @return
     */
    static String privateKeyToDer(String hexKey){


        final String head = "-----BEGIN EC PARAMETERS-----\n" +
                "BggqgRzPVQGCLQ==\n" +
                "-----END EC PARAMETERS-----\n" +
                "-----BEGIN EC PRIVATE KEY-----\n";

        final String tail = "\n-----END EC PRIVATE KEY-----";

        return head + "30310201010420" + hexKey  + "a00a06082a811ccf5501822d" + tail;
    }


//    static void SO22963581BCPEMPrivateEC() throws Exception {
//        Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
//        Reader rdr = new StringReader( );
//        Object parsed = new org.bouncycastle.openssl.PEMParser(rdr).readObject();
//        KeyPair pair = new org.bouncycastle.openssl.jcajce.JcaPEMKeyConverter().getKeyPair((org.bouncycastle.openssl.PEMKeyPair) parsed);
//        System.out.println(pair.getPrivate().getAlgorithm());
//    }

}
